﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace EntrainementOuverture
{
    /// <summary>   
    /// Logique d'interaction pour MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Permet l'ouverture d'une fenêtre de Dialogue pour ouvrir et un fichier text
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OpenFile(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();//On ouvre la fenêtre de dialogue            
            if (openFileDialog.ShowDialog() == true)//Si elle s'ouvre
                try
                {
                    txtEditor.Text = File.ReadAllText(openFileDialog.FileName);//Lecture du fichier sur le TextEditor
                    string url = openFileDialog.FileName;
                    Acces.Text = url;// throw new Exception("coucou");

                }
                catch (Exception a)//Si il y a une exceptions
                {

                    MessageBox.Show(a.Message, "Erreur");//Message d'erreur
                }
        }
        /// <summary>
        /// Permet de sauvegarder des fichiers
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SaveFile(object sender, RoutedEventArgs e)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "Text file (*.txt)|*.txt|C# file (*.cs)|*.cs";
            saveFileDialog.AddExtension = true;
            saveFileDialog.ValidateNames = true;
            if (saveFileDialog.ShowDialog() == true)
                File.WriteAllText(saveFileDialog.FileName, txtEditor.Text);
        }
        /// <summary>
        /// Permet de testé si les commandes peuvent être éxecuté
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NewCommand_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = true;
        }
        /// <summary>
        /// éxecute la commande
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NewCommand_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            txtEditor.Text = "";
        }

        /// <summary>
        /// Permet de netoyé le textBox commme un nouveau Fichier
        /// </summary>
        private void ClearNNew()
        {
            txtEditor.Clear();
        }

        /// <summary>
        /// Permet de choisir le bon menu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            MenuItem menuChoisi = (MenuItem)sender;
            String nomMenu = menuChoisi.Name;
            switch (nomMenu)
            {
                case "MenuOpen":
                    OpenFile(sender, e);
                    break;
                case "MenuSave":
                    SaveFile(sender, e);
                    break;
                case "MenuNew":
                    ClearNNew();
                    break;

            }
        }
        /// <summary>
        /// Permet de chargé la barre de status
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtEditor_SelectionChanged(object sender, RoutedEventArgs e)
        {
            int row = txtEditor.GetLineIndexFromCharacterIndex(txtEditor.CaretIndex);
            int col = txtEditor.CaretIndex - txtEditor.GetCharacterIndexFromLineIndex(row);
            lblCursorPosition.Text = "Line " + (row + 1) + ", Char " + (col + 1);
        }
    }
}
